/**
 * JimBot - Java IM Bot
 * Copyright (C) 2006-2009 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.modules.chat;

import java.util.HashSet;
import java.util.Set;
import java.util.Vector;
import java.util.concurrent.ConcurrentHashMap;
import ru.jimbot.*;
import ru.jimbot.modules.UINmanager;
import ru.jimbot.protocol.IcqProtocol;
import ru.jimbot.util.*;
import java.sql.*;
import java.util.Iterator;
import java.util.Random;

/**
 *
 * @author Prolubnikov Dmitry
 */
public class UserWork {
    public static final int UGROZA_YES = 1;
public static final int UGROZA_NO = 0;
    public static final int STATE_NO_REG = 0;
    public static final int STATE_NO_CHAT = 1;
    public static final int STATE_CHAT = 2;
    public static final int STATE_OFFLINE = 3;
    public static final int STATE_BANNED = -1;
    public static final int STATE_CAPTCHA = -2;

    private int currCountOrujie = 0;
    private int currCountUser=0;
    public DBChat db;
    //   
    private ConcurrentHashMap <String,Users> uc;
    //  -
    private ConcurrentHashMap <Integer,String> uu;
    //   
    private ConcurrentHashMap <Integer,HashSet<String>> auth;
	// 
    private ClanWork rc2;
   // private GameWork gw;
    //  
//    private ArrayList<String> ignor;
    private String serviceName = "";
    private String host, dbname, user, pass;
    public ChatServer srv;
    private RoomWork rw;
private int maxAnek = 0;



    public enum usersGroups
    {
    poweruser, moder, supermoder, admin, user, vip, akcioner, hozm, hozw, modertime,gladmin, sysadmin, gl_adm;
    }
    private ConcurrentHashMap <Integer,String> ww;
    private Random r = new Random();
    public RobAdmin radm=null;

    /** Creates a new instance of UserWork */
    public UserWork(String name) {
        try{
            serviceName = name;
            host = ChatProps.getInstance(name).getStringProperty("db.host");
            dbname = ChatProps.getInstance(name).getStringProperty("db.dbname");
            user = ChatProps.getInstance(name).getStringProperty("db.user");
            pass = ChatProps.getInstance(name).getStringProperty("db.pass");
            db = new DBChat(name);
            db.openConnection(host, dbname, user, pass);
//            Sms.setDB(db);
            uc = new ConcurrentHashMap<String,Users>();
            uu = new ConcurrentHashMap<Integer,String>();
            ww = new ConcurrentHashMap<Integer,String>();
            auth = new ConcurrentHashMap<Integer,HashSet<String>>();
//            ignor = new ArrayList();
            currCountUser=0;
            clearStatusUsers();
            rw = new RoomWork(db);
            rw.fillCash();
            rc2 = new ClanWork( db );
            rc2.StartClanCash();
            //gw = new GameWork(db);
            //gw.fillCash();
            currCountOrujie = 0;
//            readIgnore();
            maxAnek = anek();
        } catch (Exception ex){
            ex.printStackTrace();
        }
    }

//    public void readIgnore(){
//        String s;
//        try{
//            BufferedReader r = new BufferedReader(new InputStreamReader(new FileInputStream("ignore.txt"),"windows-1251"));
//            while (r.ready()){
//                s = r.readLine();
//                if(!s.equals("")){
//                    ignor.add(s);
//                }
//            }
//            r.close();
//        } catch (Exception ex){
//            ex.printStackTrace();
//        }
//    }

//    public boolean testIgnor(String sn){
//        if(ignor == null) return false;
//        if(ignor.isEmpty()) return false;
//        return ignor.contains(sn);
//    }

//    public void ignore(String sn){
//        ignor.add(sn);
//    }

    public void closeDB(){
        db.shutdown();
    }

    public int count() {
        if (currCountUser==0)
            currCountUser = (int)db.getLastIndex("users");
        return currCountUser;
    }



    public int count2() {
        return (int)db.getLastIndex("invites");
    }

public int anek() {
if (maxAnek==0)
maxAnek = (int)db.getLastIndex("aneks");
return maxAnek-1;
}

    /**
     *      
     * @param id -  
     * @return
     */
    private Users getUserFromDB(int id){
    	Vector v = db.getObjectVector("select * from users where id="+id);
    	Users u = new Users();
    	if(v.size()>0) u = (Users)v.get(0);
    	if(u.id!=0) u.group = getUserGroup(u.id);
    	return u;
    }

    /**
     *      
     * @param sn -  
     * @return
     */
    private Users getUserFromDB(String sn){
    	Vector v = db.getObjectVector("select * from users where sn='"+sn+"'");
    	Users u = new Users();
    	if(v.size()>0) u = (Users)v.get(0);
    	if(u.id!=0) u.group = getUserGroup(u.id);
    	return u;
    }

    /**
     *      
     */
    public void clearStatusUsers(){
        db.executeQuery("update users set state=1 where state=3");
        db.executeQuery("update users set state=1 where state=2");
//        db.commit();
    }

    /**
     *     
     * @param uin
     * @return
     */
    public boolean testUser(String uin){
        if(uc.containsKey(uin)){
        	return uc.get(uin).state!=0;
        }
        Users u = getUserFromDB(uin);
        if(u.id==0){
        	u.sn = uin;
        	uc.put(u.sn, u);
        	return false;
        } else {
        	uu.put(u.id, u.sn);
        	uc.put(u.sn, u);
        	return true;
        }
    }

    /**
     *   
     */

    /**
     *    
     */
    public String getUserNicks(int user_id){
//        String s="  : ";
    	String s=Messages.getString("UserWork.getUserNicks.0");
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select t.msg from events t where t.type='REG' and t.user_id=" +
                    user_id + " order by t.time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += rs.getString(1) + "; ";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }

    /**
     *     (  )
     */
    public String getUserInvites(int user_id) {
//        String s = " : ";
    	String s=Messages.getString("UserWork.getUserInvites.0");
        int i=0, k=user_id;
        while ((i=whoInviteUser(k))!=0){
            s += "["+i+"]"+getUser(i).localnick+"; ";
            k = i;
        }
        return s+"\n"+inviteList(user_id);
    }

    /**
     *   
     * @param user_id
     * @return
     */
    private String inviteList(int user_id){
        Vector<String[]> v = db.getValues("SELECT new_user FROM `invites` where user_id="+
                user_id+" order by time");
//        String s = " : ";
        String s=Messages.getString("UserWork.inviteList.0");
        for(int i=0;i<v.size();i++){
            s += "["+v.get(i)[0]+"]"+getUser(Integer.parseInt(v.get(i)[0])).localnick+"; ";
        }
        return s;
    }

    /**
     *    
     */
    private int whoInviteUser(int user_id) {
        int i=0;
        try {
            PreparedStatement pst = db.getDb().prepareStatement("select user_id from invites where new_user="+user_id);
            ResultSet rs = pst.executeQuery();
            if(rs.next()){
                i = rs.getInt(1);
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return i;
    }

    /**
     *   
     */
    public String getKickHist() {
//        String s = "20  :\n";
    	String s=Messages.getString("UserWork.getKickHist.0")+"\n";
        try {
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='KICK' order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<20;i++){
                if(rs.next()){
                    s += "["+rs.getTimestamp(1)+"] "+
                            rs.getInt(2)+"("+(rs.getInt(2)==0 ? "Admin" : getUser(rs.getInt(2)).localnick)+"), " +
                            rs.getInt(3)+"("+(rs.getInt(3)==0 ? "Admin" : getUser(rs.getInt(3)).localnick)+"), " +
                            rs.getString(4)+'\n';
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

    /**
     *   
     */
    public String getRegHist() {
        String s = " 10 :\n";
        try {
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='REG' order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += "["+rs.getTimestamp(1)+"] "+
                            rs.getInt(2)+"("+(rs.getInt(2)==0 ? "Admin" : getUser(rs.getInt(2)).localnick)+"), " +
                           // rs.getInt(3)+"("+(rs.getInt(3)==0 ? "Admin" : getUser(rs.getInt(3)).localnick)+"), " +
                            rs.getString(4)+'\n';
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }


     /**
     *   
     */
    public String getZakHist() {
        String s = "\n 5 :\n";
        try {
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='Banroom' order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<5;i++){
                if(rs.next()){
                    s += "["+rs.getTimestamp(1)+"] "+
                            rs.getInt(2)+"("+(rs.getInt(2)==0 ? "Admin" : getUser(rs.getInt(2)).localnick)+") " +
                       //     rs.getInt(3)+"("+(rs.getInt(3)==0 ? "Admin" : getUser(rs.getInt(3)).localnick)+"), " +
                            rs.getString(4)+'\n';
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

        public String getUserAnketa(int id){
        String s="";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, msg from info where type = 'ANKETA' and user_id =" + id);
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                s += "   ";
            else
                s += " : " + getUser(rs.getInt(2)).localnick + "|" + getUser(rs.getInt(2)).id + "|\n" +
                     rs.getString(3) +
                     "\n: " + rs.getTimestamp(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }

        public String getVseAnketi(){
        String s="   :\n";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select user_id from info where type = 'ANKETA'");
            ResultSet rs = pst.executeQuery();
            while(rs.next()) s += rs.getInt(1) + "\n";
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }

        public String getUserMneniya(int id){
        String s="";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2, msg from info where type = 'MNENIYA' and user_id2=" + id);
            ResultSet rs = pst.executeQuery();
            while(rs.next())
            s += ": " + rs.getTimestamp(1) + "\n" +
            getUser(rs.getInt(2)).localnick + "|" + getUser(rs.getInt(2)).id + "|: " + rs.getString(4) + "\n";
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }


        public boolean deleteRoom(Rooms r){
    	return rw.deleteRoom(r);
    }

        public String getVseMneniya(){
        String s="     :\n";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select user_id2 from info where type = 'MNENIYA'");
            ResultSet rs = pst.executeQuery();
            while(rs.next()) s += rs.getInt(1) + "\n";
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }

        public String getUserBall(int id){
        String s="";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, msg from events where type = 'GOLOS' and user_id2 =" + id + " order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<20;i++){
            if(rs.next()){
            s += " " + getUser(rs.getInt(2)).localnick + "|" + getUser(rs.getInt(2)).id + "|" +
            " " + rs.getString(3) + "  " + rs.getTimestamp(1) + "\n";
            } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }
             public String getUserWar(int id){
        String s="";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, msg from events where type = 'WarChat' and user_id2 =" + id + " order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<20;i++){
            if(rs.next()){
            s += " " + getUser(rs.getInt(2)).localnick + "|" + getUser(rs.getInt(2)).id + "|" +
            " " + rs.getString(3) + "  " + rs.getTimestamp(1) + "\n";
            } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }

      public String statUsersBall(){
      String s = "";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("SELECT id, localnick, ball FROM users WHERE ball > 0 ORDER BY ball DESC LIMIT 0,5");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<5;i++){
                if(rs.next()){
                    s += " " + rs.getInt(1) + " - " + rs.getString(2) + " ~ " + rs.getInt(3) + ";\n";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
          }
        return s;
    }



      public String statUsersAvtoritet(){
      String s = "";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("SELECT id, localnick, country  FROM users WHERE country  > 0 ORDER BY `users`.`country` DESC LIMIT 0,5");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<5;i++){
                if(rs.next()){
                    s += " " + rs.getInt(1) + " - " + rs.getString(2) + " ~ " + rs.getInt(3) + ";\n";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
          }
        return s;

   }
          public String statumvic(){
      String s = "";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("SELECT id, localnick, language  FROM users WHERE language  > 0 ORDER BY `users`.`language` DESC LIMIT 0,10");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += " " + rs.getInt(1) + " - " + rs.getString(2) + " ~ " + rs.getInt(3) + ";\n";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
          }
        return s;

   }

                  public String statumnez(){
      String s = "";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("SELECT id, localnick, answer  FROM users WHERE answer  > 0 ORDER BY `users`.`answer` DESC LIMIT 0,10");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += " " + rs.getInt(1) + " - " + rs.getString(2) + " ~ " + rs.getInt(3) + ";\n";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
          }
        return s;

   }

      public String rankstat(){
      String s = "";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("SELECT id, localnick, smskiplat  FROM users WHERE smskiplat  > 0 ORDER BY `users`.`smskiplat` DESC LIMIT 0,10");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += " " + rs.getInt(1) + " - " + rs.getString(2) + " ~ " + rs.getInt(3) + ";\n";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
          }
        return s;

   }

       public String smsstat(){
      String s = "";
        try{

            PreparedStatement pst = db.getDb().prepareStatement("SELECT id, localnick, smsstat  FROM users WHERE smsstat  > 0 ORDER BY `users`.`smsstat` DESC LIMIT 0,10");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += " " + rs.getInt(1) + " - " + rs.getString(2) + " ~ " + rs.getInt(3) + ";\n";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
          }
        return s;

   }


        public String getUserStatus(int id){
        String s="";
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select msg from info where type = 'STATUS' and user_id =" + id);
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                s += "";
            else
                s += " ~ " + rs.getString(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }

/**
* @author Clo
* @param id
* @return
*/
public Users getUsernumber(int id){
Vector v = db.getObjectVector("select * from users where number="+id);
Users u = new Users();
if(v.size()>0) u = (Users)v.get(0);
if(u.id!=0) u.group = getUserGroup(u.id);
return u;
}

     /**
     *       24 
     * @param id
     * @return
     */
    public int getCountgolosovanChange(int id) {
        String q = "SELECT count(*) FROM `events` WHERE user_id="+id+" and type='GOLOSOVAN' and (to_days( now( ) ) - to_days( time )) <1";
        Vector <String[]> v = db.getValues(q);
        return Integer.parseInt(v.get(0)[0]);
    }  

    /**
     *   
     */
    public String getSvadbaHist() {
        String s = " 10 :\n";
        try {
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='SVADBA' order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += "["+rs.getTimestamp(1)+"] "+
                           rs.getInt(2)+"("+(rs.getInt(2)==0 ? "Admin" : getUser(rs.getInt(2)).localnick)+") " +
                           rs.getString(4)+ " " +
                           rs.getInt(3)+"("+(rs.getInt(3)==0 ? "Admin" : getUser(rs.getInt(3)).localnick)+")" +'\n';
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

    /**
     *   
     */
    public String getRazvodHist() {
        String s = " 10 :\n";
        try {
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='RAZVOD' order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    s += "["+rs.getTimestamp(1)+"] "+
                           rs.getInt(2)+"("+(rs.getInt(2)==0 ? "Admin" : getUser(rs.getInt(2)).localnick)+") " +
                           rs.getString(4)+ " " +
                           rs.getInt(3)+"("+(rs.getInt(3)==0 ? "Admin" : getUser(rs.getInt(3)).localnick)+")" +'\n';
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

    public String Glavnie(){
        String ss="";
        try{
            int i=0;
            PreparedStatement pst = db.getDb().prepareStatement("SELECT user_id, val FROM `user_props` WHERE `val` IN('poweruser', 'moder','supermoder','admin','vip','akcioner','hozm','hozw','modertime','gladmin','sysadmin','gl_adm') ORDER BY user_id") ;
            ResultSet rs = pst.executeQuery();
            while(rs.next()) {
            i=rs.getInt(1);
            Users us = getUser(rs.getInt(1));
            String g = rs.getString(2);
            switch (usersGroups.valueOf(g)){
            case poweruser: ss += i + " ~ " + us.localnick + " ~ \n"; break;
            case vip: ss += i + " ~ " + us.localnick + " ~ vip\n"; break;
            case moder: ss += i + " ~ " + us.localnick + " ~ \n"; break;
            case supermoder: ss += i + " ~ " + us.localnick + " ~ \n"; break;
            case akcioner: ss += i + " ~ " + us.localnick + " ~ \n"; break;
            case admin: ss += i + " ~ " + us.localnick + " ~ \n"; break;
            case hozm: ss += i + " ~ " + us.localnick + " ~ \n"; break;
            case hozw: ss += i + " ~ " + us.localnick + " ~ \n"; break;
            case modertime: ss += i + " ~ " + us.localnick + " ~  \n"; break;
             case gladmin: ss += i + " ~ " + us.localnick + " ~  \n"; break;
          case sysadmin: ss += i + " ~ " + us.localnick + " ~  \n"; break;
          case gl_adm: ss += i + " ~ " + us.localnick + " ~  \n"; break;


            }
            }
            rs.close();
            pst.close();
    } catch (Exception ex) {
            ex.printStackTrace();
       }
        return ss;
    }


     /**
     *   
     */
    public String getUbanHist() {
      String s = "20  :\n";
      s+="|| \n";
            try {
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2 from events where type='UBAN' order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<20;i++){
                if(rs.next()){
                    s += "["+rs.getTimestamp(1)+"] "+
                    (rs.getInt(2)==0 ? "Admin" : getUser(rs.getInt(2)).localnick)+"|" +rs.getInt(2)+"|,"+
                    (rs.getInt(3)==0 ? "Admin" : getUser(rs.getInt(3)).localnick)+"|" +rs.getInt(3)+"|\n";
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
       }
        return s;
    }

//  //

        /**
          *  
          * @param id
          * @return
          */
       public Clan getClan( int id )
       {
       if( rc2.CheckClan( id ) )
       return rc2.getClan( id );
       Clan c = new Clan();
       c.setId( id );
       return c;
       }

       /**
         *      ?
         * @param id
         * @return
         */
       public boolean CheckClan( int id )
       {
       return rc2.CheckClan( id );
       }

       /**
         *   
         * @param 
         * @return
         */
       public boolean CreateClan( Clan c )
       {
       return rc2.CreateClan( c );
       }

       /**
         *    
         * @param 
         * @return
         */
       public boolean saveClan( Clan c )
       {
       return rc2.UpdateClan( c );
       }

       /**
         *    
         * @return
         */
       public Set<Integer> getClans()
       {
       return rc2.getClans();
       }

       /**
         *  
         * @param 
         * @return
         */
       public boolean DeleteClan( Clan c )
       {
       return rc2.DeleteClan( c );
       }

       /**
         *    
         * @return
         */
       public int getCountClan()
       {
       return rc2.getCountClan();
       }

       /**
         *     
         *  true     
         * @return
         */
       public boolean testClanName( String ClanName )
       {
       return rc2.TestClanName( ClanName );
       }

       /**
         *   
         * @return
         */
       public int getMaxId()
       {
       return rc2.getMaxId();
       }

       /**
        *    
        * @return
        */
       public String ListClan()
       {
       String list = " :\nid|||||\n";
       try{
       PreparedStatement pst = db.getDb().prepareStatement( "select id, name_clan,  leader_clan, room_clan, ball_clan, info_clan from clans" );
       ResultSet rs = pst.executeQuery();
       while( rs.next() )
       {
       list += "------\n";
       list += "|" + rs.getInt( 1 ) + "|" + rs.getString( 2 )  + "|" + getUser( rs.getInt( 3 ) ).localnick + "|" + rs.getInt( 4 ) + "|" + rs.getInt( 5 ) + "|" + "\n";
       list += " : " + rs.getString( 6 ) + "\n";
       list += "------\n";
       }
       rs.close();
       pst.close();
       }
       catch ( Exception ex )
       {
       ex.printStackTrace();
       }
       return list;
       }

       /**
        *      
        * @return
        */
       public String ClanTop(){
       String s = "   :\n|id|||\n";
       try{
       PreparedStatement pst = db.getDb().prepareStatement( "SELECT id, name_clan, ball_clan FROM clans WHERE ball_clan > 0 ORDER BY ball_clan DESC" );
       ResultSet rs = pst.executeQuery();
       while(rs.next())
       {
       s += "|" + rs.getInt(1) + "|" + rs.getString(2) + "|" + rs.getInt(3) + "| \n";
       }
       rs.close();
       pst.close();
       }
       catch (Exception ex)
       {
       ex.printStackTrace();
       }
       return s;
       }

       /**
        *   
        * @param id
        * @return
        */

       public String ClanMemberList( int id ){
       String s = "   ''" + getClan( id ).getName() + "'' :\n";
       Users uss = getUser( getClan( id ).getLeader() );
       s += " : " + uss.localnick + "\n";
       s += "|id|Nick|ClanGroup|\n";
       try{
       PreparedStatement pst = db.getDb().prepareStatement( "SELECT id FROM users WHERE clansman =" + id + " order by clansman desc" );
       ResultSet rs = pst.executeQuery();
       while( rs.next() )
       {
       Users u = getUser( rs.getInt( 1 ) );
       if ( u.id != getClan( id ).getLeader() )
       {
       s += "|" + u.id + "|" + u.localnick + "|" + u.clangroup + "|" + '\n';
       }
       }
       rs.close();
       pst.close();
       }
       catch (Exception ex)
       {
       ex.printStackTrace();
       }
       return s;
       }


       /**
        *    
        * @param id
        * @return
        */

       public void ClanDelAllMember( int id ){
       try{
       PreparedStatement pst = db.getDb().prepareStatement( "SELECT id FROM users WHERE clansman =" + id );
       ResultSet rs = pst.executeQuery();
       while( rs.next() )
       {
       Users u = getUser( rs.getInt( 1 ) );
       u.clansman = 0;
       u.clangroup = "";
       updateUser( u );
       }
       rs.close();
       pst.close();
       }
       catch (Exception ex)
       {
       ex.printStackTrace();
       }
       }



  ////////
     /**
     *    
     * @return
     */
    public Vector<Users> getModList()
    {
    	return db.getObjectVector("select * from users where lastMod>now()");
    }

    /**
     *   
     */
    public String getBanHist() {
//        String s = "20  :\n";
    	String s=Messages.getString("UserWork.getBanHist.0")+"\n";
        try {
            PreparedStatement pst = db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='BAN' order by time desc");
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<20;i++){
                if(rs.next()){
                    s += "["+rs.getTimestamp(1)+"] "+
                            rs.getInt(2)+"("+(rs.getInt(2)==0 ? "Admin" : getUser(rs.getInt(2)).localnick)+"), " +
                            rs.getInt(3)+"("+(rs.getInt(3)==0 ? "Admin" : getUser(rs.getInt(3)).localnick)+"), " +
                            rs.getString(4)+'\n';
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return s;
    }

    /**
     *      
     */
    public int statUsersCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("SELECT count( DISTINCT t.user_id ) " +
                    "FROM log t WHERE t.user_id <>0 AND t.time >= ?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }
	
    /**
     *   
     */
    public int statKickUsersCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select count( DISTINCT t.user_id) from log t where user_id<>0 " +
                    "and type='KICK' and time>=?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }
     public static String statKickUsers(){
     return MainProps.getAbout();
   }

    /**
     *   
     */
    public int statBanUsersCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select count( DISTINCT t.user_id) from log t where user_id<>0 " +
                    "and type='BAN' and time>=?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }

    /**
     *  
     */
    public int statRegCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select count(*) from log t where type = 'REG' " +
                    "and time>=?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }

    /**
     *   
     */
    public int statLichCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select count(*) from log t where type = 'LICH' " +
                    "and time>=?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }


    /**
     *    
     */
    public int statBanroomCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select count(*) from log t where type = 'Banroom' " +
                    "and time>=?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }

     /**
     *     24 
     * @param id
     * @return
     */
    public int getCountgolosChange(int id, int id2) {
        String q = "SELECT count(*) FROM `events` WHERE user_id="+id+" and user_id2="+id2+" and type='GOLOS' and (to_days( now( ) ) - to_days( time )) <1";
        Vector<String[]> v = db.getValues(q);
//        System.out.println(Integer.parseInt(v.get(0)[0]));
        return Integer.parseInt(v.get(0)[0]);
    }
    /**
     *    24 
     * @param id
     * @return
     */
    public int getCountWarhat(int id, int id2) {
        String q = "SELECT count(*) FROM `events` WHERE user_id="+id+" and user_id2="+id2+" and type='WarChat' and (to_days( now( ) ) - to_days( time )) <1";
        Vector<String[]> v = db.getValues(q);
//        System.out.println(Integer.parseInt(v.get(0)[0]));
        return Integer.parseInt(v.get(0)[0]);
    }
     /**
     *     
     */
    public int statBanroomColCount(){
  //      long last = System.currentTimeMillis() - 1000*3600*24;
        int s = ChatProps.getInstance(serviceName).getIntProperty("room.tyrma");
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("SELECT count(*) FROM users WHERE room="+s);
    //        pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }


    /**
     *  
     */
    public int statKickCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select count(*) from log t where type = 'KICK' " +
                    "and time>=?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }

    /**
     *  
     */
    public int statMsgCount(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        int r=0;
        try{
            PreparedStatement pst = db.getDb().prepareStatement("select count(*) from log t where type = 'OUT' and user_id<>0 " +
                    "and time>=?");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            if(!rs.next())
                r = 0;
            else
                r = rs.getInt(1);
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return r;
    }

    /**
     *  
     */
    public String statUsersTop(){
        long last = System.currentTimeMillis() - 1000*3600*24;
        String s = "";
        try{
            PreparedStatement pst;
//            if(MainProps.isExtdb())
                pst = db.getDb().prepareStatement("select t.user_id, sum(length(t.msg)) cnt " +
                        "from log t where t.type = 'OUT' and t.user_id<>0 and time>=? " +
                        "group by t.user_id order by cnt desc limit 0,10");
//            else
//                pst = db.getDb().prepareStatement("select * from " +
//                    "(select t.user_id, sum(length(t.msg)) cnt from log t where " +
//                    "t.type = 'OUT' and t.user_id<>0 and time>=? group by t.user_id " +
//                    ")tt order by tt.cnt desc ");
            pst.setTimestamp(1,new Timestamp(last));
            ResultSet rs = pst.executeQuery();
            for(int i=0;i<10;i++){
                if(rs.next()){
                    Users us = getUser(rs.getInt(1));
                    s += " " + us.id + " - " + us.localnick + " ~ " + rs.getInt(2) + ";\n";
                } else {
                    break;
                }
            }
            rs.close();
            pst.close();
        } catch (Exception ex){
            ex.printStackTrace();
        }
        return s;
    }





    /**
     *   
     */
    public String getUinStat(){
//        String s = "     :\n";
    	String s = Messages.getString("UserWork.getUinStat.0") + "\n";
        String[] uins = new String[ChatProps.getInstance(serviceName).uinCount()];
        int[] cnt = new int[ChatProps.getInstance(serviceName).uinCount()];
        for(int i=0;i<ChatProps.getInstance(serviceName).uinCount();i++){
            uins[i] = ChatProps.getInstance(serviceName).getUin(i);
            
            cnt[i] = 0;
        }



        int a=0;
        Iterator <Users> it = uc.values().iterator();
        while(it.hasNext()){
            Users u = it.next();
            if(u.state == UserWork.STATE_CHAT){
                a++;
                for(int i=0;i<uins.length;i++){
                    if(uins[i].equals(u.basesn)) cnt[i]++;
                }
            }
        }
        for(int i=0;i<uins.length;i++){
            s += i + " - " + uins[i] + " = " + cnt[i] + "\n";
        }
        return s+"  : "+a;
    }


    public String getFreeUin(){
        String[] uins = new String[ChatProps.getInstance(serviceName).uinCount()];
        int[] cnt = new int[ChatProps.getInstance(serviceName).uinCount()];
        for(int i=0;i<ChatProps.getInstance(serviceName).uinCount();i++){
            uins[i] = ChatProps.getInstance(serviceName).getUin(i);
            cnt[i] = 0;
        }
        Iterator <Users> it = uc.values().iterator();
        while(it.hasNext()){
            Users u = it.next();
            if(u.state == UserWork.STATE_CHAT){
                for(int i=0;i<uins.length;i++){
                    if(uins[i].equals(u.basesn)) cnt[i]++;
                }
            }
        }
        int k=0;
        for(int i=1;i<cnt.length;i++){
             if(cnt[i]<cnt[k]) k = i;
        }
        return uins[k];
    }

    public int getCurrUinUsers(String uin){
        Iterator <Users> it = uc.values().iterator();
        int i=0;
        while(it.hasNext()){
            Users u = it.next();
            if(u.state == UserWork.STATE_CHAT && u.basesn.equals(uin)) i++;
        }
        return i;
    }

    public Users getUser(int id) {
    	if(uu.containsKey(id)){
    		return uc.get(uu.get(id));
    	}
    	Users u = getUserFromDB(id);
    	if(u.id==0) return u; //    ,   :)
    	uu.put(id, u.sn);
    	uc.put(u.sn, u);
    	return u;
    }

    public Users getUser(String uin) {
    	if(uc.containsKey(uin)) return uc.get(uin);
    	Users u = getUserFromDB(uin);
    	if(u.id==0) return u; //    ,   :)
    	uu.put(u.id, u.sn);
    	uc.put(u.sn, u);
    	return u;
    }

    public Vector getUsers(int state) {
        return db.getObjectVector("select * from users where state = " + state);
    }

    public String getUserInfo(int id) {
        Users u = getUser(id);
        if(u.state==-1)
            return u.getInfo()+"\n"+getBanDesc(u.sn);
        else
            return u.getInfo();
    }

    public String getUserInfo(String uin) {
        Users u = getUser(uin);
        if(u.state==-1)
            return u.getInfo()+"\n"+getBanDesc(uin);
        else
            return u.getInfo();
    }

    /**
     *    ?
     * @param n
     * @return
     */
    public boolean isUsedNick(String n){
    	String q = "select count(*) from users where localnick like '"+n+"'";
    	Vector<String[]> v = db.getValues(q);
//    	System.out.println(v.get(0)[0]);
    	return !v.get(0)[0].equals("0");
    }

    /**
     *      24 
     * @param id
     * @return
     */
    public int getCountNickChange(int id) {
    	String q = "SELECT count(*) FROM `events` WHERE user_id="+id+" and type='REG' and (to_days( now( ) ) - to_days( time )) <1";
    	Vector<String[]> v = db.getValues(q);
//    	System.out.println(Integer.parseInt(v.get(0)[0]));
    	return Integer.parseInt(v.get(0)[0]);
    }


    public int getCountPmChange(int id)
   {
     String q = "SELECT count(*) FROM `events` WHERE user_id=" + id + " and type='PM' and (to_days( now( ) ) - to_days( time )) <1";
     Vector v = this.db.getValues(q);
     return Integer.parseInt(((String[])v.get(0))[0]);
   }


    /**
     *  
     * @param uin
     * @return
     */
    public String getBanDesc(String uin) {
        Vector<String[]> v = db.getValues("SELECT user_id2,time, msg FROM `events` " +
                "where type='BAN' and user_sn='"+uin+"'order by time desc");
        if(v.size()==0) return "";
        return getUser(Integer.parseInt(v.get(0)[0])).localnick+", "+
                v.get(0)[1]+", "+v.get(0)[2];
    }

    /**
     *     
     * @return
     */
    public Vector<Users> getKickList() {
    	return db.getObjectVector("select * from users where lastkick>now()");
    }

        /**
     *     
     * @return
     */
    public Vector<Users> getClosedList() {
    	return db.getObjectVector("select * from users where lastclosed>now()");
    }

    public String listUsers(){
        String s = "Users list\n";
        Iterator <Users> it = uc.values().iterator();
        while(it.hasNext()){
            Users u = it.next();
            if(u.state==STATE_BANNED) {
                s += u.id + ", " + u.localnick + ", " +
                    u.sn + ", " + u.localnick + ", " +
                    u.basesn + ", " + getStateText(u.state) + '\n';
            }
        }
        return s;
    }


    public String getStateText(int state) {
        switch (state){
            case 1: return " ";
            case 2: return " ";
            case 3: return " ";
            case -1: return "";
        }
        return "";
    }

    public String listUsers_a(){
        String s = "  :\n";
       for(int i=1;i<count();i++){
            try{
                Users u = new Users();
                u=getUser(i);
                if(u.state==2){
                    s += i + ", " + u.localnick + '\n';
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        return s;
    }

    public synchronized int addUser(Users u) {
        int id = count();

        u.id = id;
        uc.put(u.sn,u); // 
        db.insertObject(u);
//        db.commit();
        currCountUser++;
        return id;
    }

    public void updateUser(Users u) {
        uc.put(u.sn,u); // 
        db.updateObject(u);
//        db.commit();
    }

    public void reqUserInfo(String uin, IcqProtocol proc) {
        Users u = new Users();
        u.sn = uin;
        addUser(u);
        Log.info("Add user " + u.sn + ", " + u.nick + ", id=" + u.id);
    }

    public int getZarplata(int id) { //    
        String q = "SELECT count(*) FROM `events` WHERE user_id="+id+" and type='Rating' and (to_days( now( ) ) - to_days( time )) <1";
        Vector<String[]> v = db.getValues(q);
        System.out.println(Integer.parseInt(v.get(0)[0]));
        return Integer.parseInt(v.get(0)[0]);
    }



    public boolean testInvite(int id){
        db.clearOldInvites(id);
        Vector v=db.getValues("select count(*) from invites where user_id=" + id + " and new_user=0");
        if (v.size()<=0) return false;
        String s[] = (String[])v.get(0);
        if (Integer.parseInt(s[0])>0) return true;
        return false;
    }

    public boolean testInvite(String uid){
        db.clearOldInvites(uid);
        Vector v=db.getValues("select count(*) from invites where invite='" + uid + "' and new_user=0");
        if (v.size()<=0) return false;
        String s[] = (String[])v.get(0);
        if (Integer.parseInt(s[0])>0) return true;
        return false;
    }

    public String createInvite(int id){
        if(testInvite(id)) return "";
        int i= (int)count2();
        Invites p = new Invites(i, id);
        db.insertInvite(p);
//        db.commit();
        return p.invite;
    }

    public Invites getInvite(String uid){
        return db.getInvites("select * from invites where invite = '" + uid + "'");
    }

    public boolean updateInvite(String uin, String uid){
        Invites p = getInvite(uid);
        if(p==null) return false;
        p.new_user = getUser(uin).id;
        p.create_time = System.currentTimeMillis();
        db.updateInvite(p);
//        db.commit();
        return true;
    }


    /**
     *    
     */
    public String getUserPropsValue(int user_id, String name){
        try{
            Vector v=db.getUserProps(user_id);
            for(int i=0;i<v.size();i++){
                String[] ss = (String[])v.get(i);
                if(ss[0].equals(name)) return ss[1];
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return "";
    }

    public boolean setUserPropsValue(int user_id,String name, String value){
        return db.setUserProps(user_id, name, value);
    }

    /**
     *     
     */
    public String getUserGroupDefault(){
        String s = ChatProps.getInstance(serviceName).getStringProperty("auth.groups");
        if(s.equals("")) return "";
        return s.split(";")[0];
    }

    /**
     *    
     */
    public String getUserGroup(int user_id){
        if(db.existUserProps(user_id)){
            String s = getUserPropsValue(user_id,"group");
            if(s.equals(""))
                return getUserGroupDefault();
            else
                return s;
        } else
            return getUserGroupDefault();
    }

    /**
     *    
     */
    public HashSet<String> getUserAuthObjects(int user_id){
        if(auth.containsKey(user_id)){
            return auth.get(user_id);
        }
        String group = ChatProps.getInstance(serviceName).getStringProperty("auth.group_"+getUserGroup(user_id));
        String grant = getUserPropsValue(user_id,"grant");
        String revoke = getUserPropsValue(user_id,"revoke");
        HashSet<String> r = new HashSet<String>();
        if(group==null) return r;
        for(String s:group.split(";")){
        	r.add(s);
        }
        for(String s:grant.split(";")){
        	r.add(s);
        }
        for(String s:revoke.split(";")){
        	if(r.contains(s)) r.remove(s);
        }
        auth.put(user_id, r);
        return r;
    }

    /**
     *    
     */
    public String getUserAuthInfo(int user_id){
//        String s = "  ID=" + user_id +
//                "\n: " + getUserGroup(user_id) + "\n : ";
        String s = Messages.getString("UserWork.getUserAuthInfo.0", new Object[] {user_id, getUserGroup(user_id)});
        for(String sc:getUserAuthObjects(user_id)){
        	s += sc + ";";
        }
        return s;
    }

    public String getUserAuthInfo(String sn){
        if(ChatProps.getInstance(serviceName).testAdmin(sn))
            return "   ";
        return getUserAuthInfo(getUser(sn).id);
    }

    /**
     *   
     */
    public boolean authorityCheck(int user_id, String obj){
    	return getUserAuthObjects(user_id).contains(obj);
    }

    public boolean authorityCheck(String sn, String obj){
        if(ChatProps.getInstance(serviceName).testAdmin(sn)) return true;
        return authorityCheck(getUser(sn).id,obj);
    }

    /**
     *   
     */
    public boolean grantUser(int user_id, String authObj){
    	HashSet<String> r = getUserAuthObjects(user_id);
    	if(r.contains(authObj)) return false;
    	r.add(authObj);
    	auth.put(user_id, r);
    	saveUserAuth(user_id);
    	return true;
    }

    /**
     *     
     * @param user_id
     */
    private void saveUserAuth(int user_id) {
    	HashSet<String> u = getUserAuthObjects(user_id);
    	HashSet<String> g = new HashSet<String>();
    	for(String s:ChatProps.getInstance(serviceName).getStringProperty("auth.group_"+getUserGroup(user_id)).split(";")){
    		g.add(s);
    	}
    	String grant = "";
    	String revoke = "";
    	for(String s:u)
    		if(!g.contains(s))
    			grant += (grant.length()==0 ? "" : ";") + s;
    	for(String s:g)
    		if(!u.contains(s))
    			revoke += (revoke.length()==0 ? "" : ";") + s;
    	db.setUserProps(user_id, "grant", grant);
    	db.setUserProps(user_id, "revoke", revoke);
    }

    /**
     * deleteUser
     * @param uin
     */
   public void deleteUser(String uin) {
     Users u = getUserFromDB(uin);
     this.uu.remove(Integer.valueOf(u.id));
     this.uc.remove(u.sn);
   }

    /**
     *   
     */
    public boolean revokeUser(int user_id, String authObj){
    	HashSet<String> r = getUserAuthObjects(user_id);
    	if(!r.contains(authObj)) return false;
    	r.remove(authObj);
    	auth.put(user_id, r);
    	saveUserAuth(user_id);
    	return true;
    }

    /**
     *         
     */
    public void clearCashAuth(int user_id){
        if(auth.containsKey(user_id)) auth.remove(user_id);
        if(uu.containsKey(user_id)){
            Users u = uc.get(uu.get(user_id));
            u.group = this.getUserGroup(user_id);
            uc.put(u.sn, u);
        }
    }

    /**
     *  
     * @param id
     * @return
     */
    public Rooms getRoom(int id){
        if(rw.checkRoom(id))
            return rw.getRoom(id);
        Rooms r = new Rooms();
        r.setId(id);
        return r;
    }

    /**
     *    ?
     * @param id
     * @return
     */
    public boolean checkRoom(int id){
    	return rw.checkRoom(id);
    }

    /**
     *   
     * @param r
     * @return
     */
    public boolean createRoom(Rooms r){
    	return rw.createRoom(r);
    }

    /**
     *    
     * @param r
     * @param pass
     * @return
     */
    public boolean saveRoom(Rooms r, String pass){
    	return rw.updateRoom(r, pass);
    }

    /**
     *    
     * @return
     */
    public Set<Integer> getRooms() {
    	return rw.getRooms();
    }

     public int count5() {
        if (currCountUser==0)
            currCountUser = (int)db.getLastIndex("victorina");
        return currCountUser;
    }

       public int getRND(int i){
        return r.nextInt(i);
    }

//=====================================================================================

       public int getCountGame(int id) {
    String q = "SELECT count(*) FROM `events` WHERE user_id="+id+" and type='MILLIONER' and (to_days( now( ) ) - to_days( time )) <1";
    Vector<String[]> v = db.getValues(q);
    return Integer.parseInt(v.get(0)[0]);
    }


//       public int getCountGame(int id) {
//String q = "SELECT count(*) FROM `events` WHERE user_id="+id+" and type='GAME' and (to_days( now( ) ) - to_days( time )) <1";
//Vector<String[]> v = db.getValues(q);
////System.out.println(Integer.parseInt(v.get(0)[0]));
//return Integer.parseInt(v.get(0)[0]);
//}
/**
*  
*/
//public Questions getQuestions(int id){
//if(gw.checkQuestion(id))
//return gw.getQuestion(id);
//Questions q = new Questions();
//q.setId(id);
//return q;
//}
///**
//*   
//*/
//public Set<Integer> getQuestions() {
//return gw.getQuestions();
//}
///**
//*    
//*/
//public int getCountQuestions(){
//return gw.getCountQuestions();
//}
///**
//*   ?
//*/
//public boolean checkQuestion(int id){
//return gw.checkQuestion(id);
//}
public String getInfo(){
try {
PreparedStatement pst = db.getDb().prepareStatement("select * from inforob ORDER BY RAND( ) LIMIT 0 , 1");
ResultSet rs = pst.executeQuery();
if(rs.next()) return rs.getString(2);
rs.close();
pst.close();
} catch (Exception ex) {}
return "";
}


/**
 *  
 * @param id
 * @param msg
 */
public void AddReklama(int id, String information) {
try {
PreparedStatement pst = (PreparedStatement) db.getDb().prepareStatement("insert into inforob values(?, ?)");
pst.setInt(1,id);
pst.setString(2,information);
pst.execute();
pst.close();
}catch (Exception ex) {
ex.printStackTrace();}
}

/**
 *  
 * @param id
 * @return
 */
public String getReklama() {
try {
PreparedStatement pst =  (PreparedStatement) db.getDb().prepareStatement("select information from inforob ORDER BY RAND( ) LIMIT 0 , 1");
ResultSet rs = pst.executeQuery();
if(rs.next()) return rs.getString(1);
rs.close();
pst.close();
} catch (Exception ex){
ex.printStackTrace();
}
return "";
}



/**
*  .
*/
  public String getWeddingHistory()
  {
    String s = ": 10  .\n";
    try {
      PreparedStatement pst = this.db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='SVADBA' order by time desc");
      ResultSet rs = pst.executeQuery();
      for (int i = 0; i < 10; ++i) {
        if (rs.next()) {
          s = s + "[" + rs.getTimestamp(1) + "] " + getUser(rs.getInt(2)).localnick + "["+ rs.getInt(2) + "]  " +  getUser(rs.getInt(3)).localnick + "["+ rs.getInt(3) + "] " + rs.getString(4) +  '\n';
        }
      }
      rs.close();
      pst.close();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    return s;
  }

/**
*  .
*/
  public String getDivorceHistory()
  {
    String s = ": 10  .\n";
    try {
      PreparedStatement pst = this.db.getDb().prepareStatement("select time, user_id, user_id2, msg from events where type='RAZVOD' order by time desc");
      ResultSet rs = pst.executeQuery();
      for (int i = 0; i < 10; ++i) {
        if (rs.next()) {
           s = s + "[" + rs.getTimestamp(1) + "] " + getUser(rs.getInt(2)).localnick + "["+ rs.getInt(2) + "]  " +  getUser(rs.getInt(3)).localnick + "["+ rs.getInt(3) + "] " + rs.getString(4) +  '\n';
           }
      }
      rs.close();
      pst.close();
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    return s;
  }













  /**
 *  
 * @param id
 * @return
 */
public String GetAneks(int id) {
String s = "";
try {
PreparedStatement pst =  (PreparedStatement) db.getDb().prepareStatement("select text from aneks where id="+id);
ResultSet rs = pst.executeQuery();
if(rs.next()){
s = " #"+ id + ":\n" + rs.getString(1);
}
rs.close();
pst.close();
} catch (Exception ex){
ex.printStackTrace();
}
return s;
}


 public Vector getUsersUgroza(int ugroza) {
        return db.getObjectVector("select * from users where ugroza = " + ugroza);
        }

}
