/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ru.jimbot.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;
import ru.jimbot.table.UserPreference;
import ru.jimbot.util.Log;

/**
 * @author Warik777
 */
public class BarProps {

public static HashMap<String,BarProps> props = new HashMap<String,BarProps>();
public String PROPS_FILE = "";
public String PROPS_FOLDER = "";
public String ENCODING = "windows-1251";
private Properties   appProps;

/** Creates a new instance of BarProps */
public BarProps() {}

/**
 * @param name -  
 * @return
 */
public static BarProps getInstance(String name){
if(props.containsKey(name)) {
return props.get(name);
} else {
BarProps p = new BarProps();
p.PROPS_FILE = "./services/"+name+"/bar.xml";
p.PROPS_FOLDER = "./services/"+name;
p.setDefault();
p.load();
props.put(name, p);
return p;
}
}

public void setDefault() {
appProps = new Properties();
setIntProperty("bar.barCount", 0);
}

/**
 * @param id -  
 * @return
 */
public UserPreference[] getBatPreference(int id){
UserPreference[] p = {
new UserPreference(UserPreference.CATEGORY_TYPE, "bar"," ["+id+"]",""),
new UserPreference(UserPreference.STRING_TYPE,  "bar.name"+id," ",getStringProperty("bar.name"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "bar.price"+id," ",getIntProperty("bar.price"+id)),
new UserPreference(UserPreference.INTEGER_TYPE, "bar.intoxication"+id,"  ",getIntProperty("bar.intoxication"+id))
};
return p;
}

/**
 *  
 * @return
 */
public int barCount(){
return getIntProperty("bar.barCount");
}

/**
 *  
 * @param i
 * @return
 */
public String getName(int i){
return getStringProperty("bar.name"+i);
}

/**
 *  
 * @param i
 * @return
 */
public int getPrice(int i){
return getIntProperty("bar.price"+i);
}

/**
 *  
 * @param i -  
 * @return
 */
public int getIntoxication(int i){
return getIntProperty("bar.intoxication"+i);
}

/**
 *  
 * @param i
 * @param name - 
 * @param price - 
 * @param intoxication -  
 */
public void setBar(int i, String name, int price, int intoxication){
setStringProperty("bar.name"+i, name);
setIntProperty("bar.price"+i, price);
setIntProperty("bar.intoxication" + i, intoxication);
}

/**
 *   
 * @param name - 
 * @param price - 
 * @param intoxication -  
 */
public int addBar(String name, int price, int intoxication){
int c = barCount();
setIntProperty("bar.barCount",c + 1);
setStringProperty("bar.name"+c, name);
setIntProperty("bar.price" + c, price);
setIntProperty("bar.intoxication" + c, intoxication);
return c;
}

/**
 *  
 * @param c
 */
public void delBar(int c) {
//   
for(int i=0; i<(barCount()-1); i++){
if(i>=c){
setStringProperty("bar.name" + i, getName(i+1));
setIntProperty("bar.price" + i, getPrice(i+1));
setIntProperty("bar.intoxication" + i, getIntoxication(i+1));
}
}
//   
appProps.remove("bar.name"+(barCount()-1));
appProps.remove("bar.price"+(barCount()-1));
appProps.remove("bar.intoxication"+(barCount()-1));
setIntProperty("bar.barCount", (barCount()-1));
}


    @SuppressWarnings("CallToThreadDumpStack")
public void load(  ) {
File file = new File(PROPS_FILE);
if(!file.exists()){
String[] xml = PROPS_FILE.split("/");
Log.error(xml[2] + ".xml  !");
return;
}
setDefault();
try {
FileInputStream fi = new FileInputStream(file);
appProps.loadFromXML(fi);
fi.close();
Log.info("Load DataBase XML Bar");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error opening DataBase XML Bar: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void save() {
File file = new File(PROPS_FILE);
File dir = new File(this.PROPS_FOLDER);
try {
if(!dir.exists()) {dir.mkdirs();}
FileOutputStream fo = new FileOutputStream(file);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info("Save DataBase XML Bar");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Bar: ");
}
}

    @SuppressWarnings("CallToThreadDumpStack")
public void AddXmlConfig (String name){
String Xml = "./services/" + name + "/bar.xml";
File NEW = new File(Xml);
try {
FileOutputStream fo = new FileOutputStream(NEW);
appProps.storeToXML(fo, "DataBase XML for jImBot properties");
fo.close();
Log.info(name + ".xml   !");
} catch (Exception ex) {
ex.printStackTrace();
Log.error("Error saving DataBase XML Bar: ");
}
}

public Properties getProps(){
return appProps;
}

public void registerProperties(Properties _appProps) {
appProps = _appProps;
}

public String getProperty(String key) {
return appProps.getProperty(key);
}

public String getStringProperty(String key) {
return appProps.getProperty(key);
}

public String getProperty(String key, String def) {
return appProps.getProperty(key,def);
}

public void setProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setStringProperty(String key, String val) {
appProps.setProperty(key,val);
}

public void setIntProperty(String key, int val) {
appProps.setProperty(key,Integer.toString(val));
}

public void setBooleanProperty(String key, boolean val) {
appProps.setProperty(key, val ? "true":"false");
}

public int getIntProperty(String key) {
return Integer.parseInt(appProps.getProperty(key));
}

public boolean getBooleanProperty(String key) {
return Boolean.valueOf(appProps.getProperty(key)).booleanValue();
}


}