/**
 * JimBot - Java IM Bot
 * Copyright (C) 2006-2009 JimBot project
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package ru.jimbot.util;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import ru.jimbot.Manager;

/**
 *    .   .
 * @author nek, Warik777
 */

public class CreateService {
private static final String DRIVER = "com.mysql.jdbc.Driver";
private static final String DATABASE_URL = "jdbc:mysql://localhost:3306/";
private static Connection connection = null;
private static Statement statement = null;
private static Connection con = null;
private static Statement st = null;

/**
* @param name  
* @param user -   
* @param pass -    
* @param dbname -   
* @param menu -   
*/
public static void initMySQLService(String name, String user, String pass, String dbname, String menu) {
Log.info("Create database for service \"" + name + "\" init ...");
try {
Class.forName(DRIVER).newInstance();
try {
//connection = DriverManager.getConnection(DATABASE_URL, "root", MainProps.getStringProperty("db.pass"));

connection = DriverManager.getConnection(DATABASE_URL, MainProps.getStringProperty("db.main.user"), MainProps.getStringProperty("db.pass"));
statement = connection.createStatement();
//  
statement.executeUpdate("CREATE USER '"+dbname+"'@'localhost' IDENTIFIED BY '"+user+"';");
//     
statement.executeUpdate("GRANT USAGE ON * . * TO '"+user+"'@'localhost' IDENTIFIED BY '"+pass+"' WITH MAX_QUERIES_PER_HOUR 0 MAX_CONNECTIONS_PER_HOUR 0 MAX_UPDATES_PER_HOUR 0 MAX_USER_CONNECTIONS 0;");
//     
statement.executeUpdate("CREATE DATABASE IF NOT EXISTS `"+dbname+"`;");
//       
statement.executeUpdate("GRANT ALL PRIVILEGES ON `"+dbname+"` . * TO '"+user+"'@'localhost';");
//  
statement.executeUpdate("FLUSH PRIVILEGES;");
//  
statement.executeUpdate("ALTER DATABASE `"+dbname+"` DEFAULT CHARACTER SET "+menu+" COLLATE "+menu+"_general_ci");
//  
statement.close();
connection.close();
//  
createTebles(st, con, "templates/db.sql", user, pass, dbname, name);
//  
setProps(name, user, pass, dbname);
} catch (SQLException e) {
e.printStackTrace();
statement.close();
connection.close();
}
} catch (Exception ex) {
ex.printStackTrace();
}
}

/**
*     
* @param user -   
* @param pass -    
* @param dbname -   
* @param name  
*/
private static void setProps(String name, String user, String pass, String dbname) {
try {
Manager.getInstance().getService(name).getProps().setStringProperty("db.user", user);
Manager.getInstance().getService(name).getProps().setStringProperty("db.pass", pass);
Manager.getInstance().getService(name).getProps().setStringProperty("db.dbname", dbname);
Manager.getInstance().getService(name).getProps().save();
Log.info("Save property service \""+name+"\"");
Log.info("DB User: "+user);
Log.info("DB Pass: "+pass);
Log.info("DB BaseName: "+dbname);
} catch (Exception e) {
e.printStackTrace();
}
}

/**
*    
* @param st
* @param con
* @param file
* @param user -   
* @param pass -    
* @param dbname -   
* @param Service -  
* @throws IOException
* @throws SQLException
*/
private static void createTebles(Statement st, Connection con, String file, String user, String pass, String dbname, String Service) throws
IOException, SQLException {
con = DriverManager.getConnection(DATABASE_URL +dbname, user, pass);
st = con.createStatement();
BufferedReader buffer = new BufferedReader(new InputStreamReader(new FileInputStream(file),"UTF-8"));
while (buffer.ready()) {
//  
st.executeUpdate(buffer.readLine());
}
Log.info("Creating a database for the service \"" + Service + "\" completed!");
st.close();
con.close();
return;
}

}